// STUploadDoc.cpp : implementation of the CSTUploadDoc class
//

#include "stdafx.h"
#include "STUpload.h"

#include "STUploadDoc.h"
#include "MainFrm.h"
#include "ConflictDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc

IMPLEMENT_DYNCREATE(CSTUploadDoc, CDocument)

BEGIN_MESSAGE_MAP(CSTUploadDoc, CDocument)
	//{{AFX_MSG_MAP(CSTUploadDoc)
	ON_COMMAND(ID_DATA_IMPORT, OnDataImport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc construction/destruction

CSTUploadDoc::CSTUploadDoc()
{
	m_strCurrentFund = "";
}

CSTUploadDoc::~CSTUploadDoc()
{
}

BOOL CSTUploadDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc serialization

void CSTUploadDoc::Serialize(CArchive& ar)
{
  m_DocList.Serialize( ar );

  if (ar.IsStoring())
  {
    ar << m_strCurrentFund;	
  }
  else
  {
    ar >> m_strCurrentFund;

    //      Select Fund     
    CMainFrame* pWnd = 
      dynamic_cast< CMainFrame * > (AfxGetMainWnd());

    if( pWnd ) 
    // He       
    //        
    //   
    {
      //       
      pWnd->UpdateFundList( m_DocList, m_strCurrentFund );
      pWnd->SetFundsVisible( TRUE );
    }
  }
}

/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc diagnostics

#ifdef _DEBUG
void CSTUploadDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSTUploadDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc commands

void CSTUploadDoc::OnDataImport() 
{
    // String to customize File Dialog
CString strFilter = "Data Files (*.dat)|*.dat|All Files (*.*)|*.*||";
CFileDialog aFileDialog( TRUE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, strFilter);
int nID = aFileDialog.DoModal();
if(nID == IDOK) 
{
  CStdioFile aFile; 
  CFileException fx;
  if ( !aFile.Open( aFileDialog.GetPathName(), CFile::modeRead | CFile::typeText, &fx ) )
  {
    TCHAR buf[ 255 ];
    fx.GetErrorMessage( buf, 255 );
    CString strPrompt( buf );
    AfxMessageBox( strPrompt );
    return;
  }
  LoadData(aFile); 
}

	
}

BOOL CSTUploadDoc::LoadData(CStdioFile &infile)
{
  //    NULL
  ASSERT( infile.m_hFile != NULL );
	
  //       CStocData
  //    CSTUploadDoc::m_DocList  
  //   .
  CStockDataList TempList;

  //      
  TempList.AddHead( &m_DocList );

  //   	
  CString strTemp;

  //  
  COleDateTime Today = COleDateTime::GetCurrentTime();;
  COleDateTime FileDate;
  CString strFileHeader;

  int addedCtr = 0;	//    
  int discardedCtr = 0;  //   

  BOOL bFirstLine = TRUE;

  while( infile.ReadString( strTemp ) )
  {
    BOOL bValidDate = FALSE;
    CString strFund;
    CString strDate;
		
    //   
    if( strTemp.GetLength() == 0 ) continue;

    if( bFirstLine )
    {
      //    
      strFileHeader = strTemp.Left(18);
      strFileHeader.TrimRight();
      strDate = strTemp.Mid( 18, 10 );
    }
    else
    {
      strFund = strTemp.Left(8);
      strFund.TrimRight();
      strDate = strTemp.Mid( 8, 10 );
    }

    int nYear = atoi( strDate.Right( 4 ));
    int nMonth = atoi( strDate.Left( 2 ));
    int nDay = atoi( strDate.Mid( 3, 2 ));
	
    COleDateTime aDate( nYear, nMonth, nDay, 0, 0, 0 );
		
    if( aDate.GetStatus() != COleDateTime::valid )
    {
      if( bFirstLine )
      {
        //      - , 
        //   
        AfxMessageBox( "Invalid File Format" );
        return FALSE;
      }
      else
      {
        //      -  
        //  
        discardedCtr++;
        continue;
      }
    }

    if ( bFirstLine )
    {
      //     -     
      FileDate = aDate;
      bFirstLine = FALSE;
      continue;
    }

    double dPrice = atof( strTemp.Mid( 19 ));

    //   CStockData      t 
    CStockData aStData( strFund, aDate, dPrice );
    CStockDataList::errorstatus err;
    POSITION CurPos = TempList.AddSorted( aStData, err );

    switch( err )
    {
      //  -
      case CStockDataList::duplicate_entry :
        discardedCtr ++ ;
        continue;

      //      
      case CStockDataList::conflicting_entry :  
      {
        //  :     
        // ,      
        CConflictDialog aDialog;

        //  ,    
        //     
        CString strText = "Existing entry:\n\n";

        CStockData SDTemp = TempList.GetAt( CurPos );

        strText += SDTemp.GetAsString();
        strText += "\n\nReplacement entry:\n\n";
        strText += aStData.GetAsString();

        //      
        aDialog.m_REditText = strText;

        switch( aDialog.DoModal() )
        {
          case IDABORT : //   
          return FALSE;

          case IDCANCEL : //  
          discardedCtr++ ;
          continue;

          case IDOK :  //   
          TempList.SetAt( CurPos, aStData );
        }
      }
			
      default:  // OK
      addedCtr++ ;
      }
    }

    //   -   
    CString strPrompt;
    strPrompt.Format( 
      "Import of file %s complete:\nRecords loaded: %d \
      \nRecords discarded: %d  \
      \n\nHit OK to load data into document.",
      strFileHeader, addedCtr, discardedCtr );

    if ( AfxMessageBox( strPrompt, MB_OKCANCEL ) == IDOK )
    {
      //   
      m_DocList.RemoveAll();
      m_DocList.AddHead( &TempList );

      //     
      CMainFrame * pWnd = 
        dynamic_cast< CMainFrame * > (AfxGetMainWnd());

      if ( pWnd )
      {
        pWnd->UpdateFundList( m_DocList );
        //      
        pWnd->SetFundsVisible( TRUE );
      }

      return TRUE;
    }
    else
      return FALSE;

}
